// WARNING: DO NOT EDIT THIS FILE. THIS FILE IS MANAGED BY SPRING ROO.
// You may push code into the target .java compilation unit if you wish to edit any member(s).

package joejava.pensieve.web;

import java.io.UnsupportedEncodingException;
import java.lang.Long;
import java.lang.String;
import java.util.Collection;
import javax.annotation.PostConstruct;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import joejava.pensieve.domain.Address;
import joejava.pensieve.domain.Contact;
import org.joda.time.format.DateTimeFormat;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.core.convert.converter.Converter;
import org.springframework.core.convert.support.GenericConversionService;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.util.UriUtils;
import org.springframework.web.util.WebUtils;

privileged aspect ContactController_Roo_Controller {
    
    @Autowired
    private GenericConversionService ContactController.conversionService;
    
    @RequestMapping(method = RequestMethod.POST)
    public String ContactController.create(@Valid Contact contact, BindingResult result, Model model, HttpServletRequest request) {
        if (result.hasErrors()) {
            model.addAttribute("contact", contact);
            addDateTimeFormatPatterns(model);
            return "contacts/create";
        }
        contact.persist();
        return "redirect:/contacts/" + encodeUrlPathSegment(contact.getId().toString(), request);
    }
    
    @RequestMapping(params = "form", method = RequestMethod.GET)
    public String ContactController.createForm(Model model) {
        model.addAttribute("contact", new Contact());
        addDateTimeFormatPatterns(model);
        return "contacts/create";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public String ContactController.show(@PathVariable("id") Long id, Model model) {
        addDateTimeFormatPatterns(model);
        model.addAttribute("contact", Contact.findContact(id));
        model.addAttribute("itemId", id);
        return "contacts/show";
    }
    
    @RequestMapping(method = RequestMethod.GET)
    public String ContactController.list(@RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model model) {
        if (page != null || size != null) {
            int sizeNo = size == null ? 10 : size.intValue();
            model.addAttribute("contacts", Contact.findContactEntries(page == null ? 0 : (page.intValue() - 1) * sizeNo, sizeNo));
            float nrOfPages = (float) Contact.countContacts() / sizeNo;
            model.addAttribute("maxPages", (int) ((nrOfPages > (int) nrOfPages || nrOfPages == 0.0) ? nrOfPages + 1 : nrOfPages));
        } else {
            model.addAttribute("contacts", Contact.findAllContacts());
        }
        addDateTimeFormatPatterns(model);
        return "contacts/list";
    }
    
    @RequestMapping(method = RequestMethod.PUT)
    public String ContactController.update(@Valid Contact contact, BindingResult result, Model model, HttpServletRequest request) {
        if (result.hasErrors()) {
            model.addAttribute("contact", contact);
            addDateTimeFormatPatterns(model);
            return "contacts/update";
        }
        contact.merge();
        return "redirect:/contacts/" + encodeUrlPathSegment(contact.getId().toString(), request);
    }
    
    @RequestMapping(value = "/{id}", params = "form", method = RequestMethod.GET)
    public String ContactController.updateForm(@PathVariable("id") Long id, Model model) {
        model.addAttribute("contact", Contact.findContact(id));
        addDateTimeFormatPatterns(model);
        return "contacts/update";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public String ContactController.delete(@PathVariable("id") Long id, @RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model model) {
        Contact.findContact(id).remove();
        model.addAttribute("page", (page == null) ? "1" : page.toString());
        model.addAttribute("size", (size == null) ? "10" : size.toString());
        return "redirect:/contacts?page=" + ((page == null) ? "1" : page.toString()) + "&size=" + ((size == null) ? "10" : size.toString());
    }
    
    @ModelAttribute("addresses")
    public Collection<Address> ContactController.populateAddresses() {
        return Address.findAllAddresses();
    }
    
    Converter<Address, String> ContactController.getAddressConverter() {
        return new Converter<Address, String>() {
            public String convert(Address address) {
                return new StringBuilder().append(address.getStreetAddress()).append(" ").append(address.getCity()).append(" ").append(address.getStateProv()).toString();
            }
        };
    }
    
    Converter<Contact, String> ContactController.getContactConverter() {
        return new Converter<Contact, String>() {
            public String convert(Contact contact) {
                return new StringBuilder().append(contact.getFirstName()).append(" ").append(contact.getLastName()).append(" ").append(contact.getBirthDate()).toString();
            }
        };
    }
    
    @PostConstruct
    void ContactController.registerConverters() {
        conversionService.addConverter(getAddressConverter());
        conversionService.addConverter(getContactConverter());
    }
    
    void ContactController.addDateTimeFormatPatterns(Model model) {
        model.addAttribute("contact_birthdate_date_format", DateTimeFormat.patternForStyle("S-", LocaleContextHolder.getLocale()));
    }
    
    private String ContactController.encodeUrlPathSegment(String pathSegment, HttpServletRequest request) {
        String enc = request.getCharacterEncoding();
        if (enc == null) {
            enc = WebUtils.DEFAULT_CHARACTER_ENCODING;
        }
        try {
            pathSegment = UriUtils.encodePathSegment(pathSegment, enc);
        }
        catch (UnsupportedEncodingException uee) {}
        return pathSegment;
    }
    
}
